/* **********************************************************************
    Copyright 2003 Rensselaer Polytechnic Institute.

    All worldwide rights reserved. A license to use, copy, modify and
    distribute this software for noncommercial research purposes only is
    hereby granted, provided that this copyright notice and accompanying
    disclaimer is not modified or removed from the software.

    DISCLAIMER: The software is distributed" AS IS" without any express or
    implied warranty, including but not limited to, any implied warranties
    of merchantability or fitness for a particular purpose or any warrant)'
    of non-infringement of any current or pending patent rights. The authors
    of the software make no representations about the suitability of this
    software for any particular purpose. The entire risk as to the quality
    and performance of the software is with the user. Should the software
    prove defective, the user assumes the cost of all necessary servicing,
    repair or correction. In particular, neither Rensselaer Polytechnic
    Institute, nor the authors of the software are liable for any indirect,
    special, consequential, or incidental damages related to the software,
    to the maximum extent the law permits.
*/

package edu.tests.washington.cac.calendar.data;

import edu.washington.cac.calendar.data.Event;

import java.util.HashMap;
import java.util.Iterator;

/** Test the PublicEvents class
 *
 * @author Mike Douglass     douglm@rpi.edu
 * @version 1.0
 */
public class PublicEventsTest extends DataTestCommon {

  /* ====================================================================
   *                   Event methods
   * ==================================================================== */

  /**
    Test the add and delete event methods
   */
  public void testAddDeleteEvent() throws Throwable {
    init();

    /** Some test events */
    Event event1;
    Event event2;

    try {
      event1 = newEvent(0);
      event2 = newEvent(1);
    } catch (Throwable t) {
      t.printStackTrace();
      throw new RuntimeException("Exception creating dummy event");
    }

    assertTrue(addEvent(event1));
    assertTrue(addEvent(event2));

    /* Ensure we only have the two events */

    Iterator it1 = pe.elements();
    checkTable = (HashMap)events.clone();

    checkForEvent(it1);
    checkForEvent(it1);

    assertTrue(!it1.hasNext());

    pe.delete(event1);
    pe.delete(event2);

    /* Ensure no events */

    Iterator it2 = pe.elements();
    assertTrue(!it2.hasNext());
  }
}

